diff --git a/sys/bus/u4b/input/atp.c b/sys/bus/u4b/input/atp.c
index de02b38151..b456bf97f1 100644
--- a/sys/bus/u4b/input/atp.c
+++ b/sys/bus/u4b/input/atp.c
@@ -429,100 +745,183 @@ static struct usb_fifo_methods atp_fifo_methods = {
 };
 
 /* device initialization and shutdown */
-static usb_error_t   atp_req_get_report(struct usb_device *udev, void *data);
-static int           atp_set_device_mode(device_t dev, interface_mode mode);
-static void          atp_reset_callback(struct usb_xfer *, usb_error_t);
-static int           atp_enable(struct atp_softc *sc);
-static void          atp_disable(struct atp_softc *sc);
-static int           atp_softc_populate(struct atp_softc *);
-static void          atp_softc_unpopulate(struct atp_softc *);
+static usb_error_t   atp_set_device_mode(struct atp_softc *, interface_mode);
+static void	     atp_reset_callback(struct usb_xfer *, usb_error_t);
+static int	     atp_enable(struct atp_softc *);
+static void	     atp_disable(struct atp_softc *);
 
 /* sensor interpretation */
-static __inline void atp_interpret_sensor_data(const int8_t *, u_int, atp_axis,
-			 int *, atp_protocol);
-static __inline void atp_get_pressures(int *, const int *, const int *, int);
-static void          atp_detect_pspans(int *, u_int, u_int, atp_pspan *,
-			 u_int *);
+static void	     fg_interpret_sensor_data(struct atp_softc *, u_int);
+static void	     fg_extract_sensor_data(const int8_t *, u_int, atp_axis,
+    int *, enum fountain_geyser_trackpad_type);
+static void	     fg_get_pressures(int *, const int *, const int *, int);
+static void	     fg_detect_pspans(int *, u_int, u_int, fg_pspan *, u_int *);
+static void	     wsp_interpret_sensor_data(struct atp_softc *, u_int);
 
 /* movement detection */
-static boolean_t     atp_match_stroke_component(atp_stroke_component *,
-                         const atp_pspan *, atp_stroke_type);
-static void          atp_match_strokes_against_pspans(struct atp_softc *,
-			 atp_axis, atp_pspan *, u_int, u_int);
-static boolean_t     atp_update_strokes(struct atp_softc *,
-			 atp_pspan *, u_int, atp_pspan *, u_int);
-static __inline void atp_add_stroke(struct atp_softc *, const atp_pspan *,
-			 const atp_pspan *);
-static void          atp_add_new_strokes(struct atp_softc *, atp_pspan *,
-			 u_int, atp_pspan *, u_int);
-static void          atp_advance_stroke_state(struct atp_softc *,
-			 atp_stroke *, boolean_t *);
-static void          atp_terminate_stroke(struct atp_softc *, u_int);
-static __inline boolean_t atp_stroke_has_small_movement(const atp_stroke *);
-static __inline void atp_update_pending_mickeys(atp_stroke_component *);
-static void          atp_compute_smoothening_scale_ratio(atp_stroke *, int *,
-			 int *);
-static boolean_t     atp_compute_stroke_movement(atp_stroke *);
+static boolean_t     fg_match_stroke_component(fg_stroke_component_t *,
+    const fg_pspan *, atp_stroke_type);
+static void	     fg_match_strokes_against_pspans(struct atp_softc *,
+    atp_axis, fg_pspan *, u_int, u_int);
+static boolean_t     wsp_match_strokes_against_fingers(struct atp_softc *,
+    wsp_finger_t *, u_int);
+static boolean_t     fg_update_strokes(struct atp_softc *, fg_pspan *, u_int,
+    fg_pspan *, u_int);
+static boolean_t     wsp_update_strokes(struct atp_softc *,
+    wsp_finger_t [WSP_MAX_FINGERS], u_int);
+static void fg_add_stroke(struct atp_softc *, const fg_pspan *, const fg_pspan *);
+static void	     fg_add_new_strokes(struct atp_softc *, fg_pspan *,
+    u_int, fg_pspan *, u_int);
+static void wsp_add_stroke(struct atp_softc *, const wsp_finger_t *);
+static void	     atp_advance_stroke_state(struct atp_softc *,
+    atp_stroke_t *, boolean_t *);
+static boolean_t atp_stroke_has_small_movement(const atp_stroke_t *);
+static void	     atp_update_pending_mickeys(atp_stroke_t *);
+static boolean_t     atp_compute_stroke_movement(atp_stroke_t *);
+static void	     atp_terminate_stroke(struct atp_softc *, atp_stroke_t *);
 
 /* tap detection */
-static __inline void atp_setup_reap_time(struct atp_softc *, struct timeval *);
-static void          atp_reap_zombies(struct atp_softc *, u_int *, u_int *);
-static void          atp_convert_to_slide(struct atp_softc *, atp_stroke *);
+static boolean_t atp_is_horizontal_scroll(const atp_stroke_t *);
+static boolean_t atp_is_vertical_scroll(const atp_stroke_t *);
+static void	     atp_reap_sibling_zombies(void *);
+static void	     atp_convert_to_slide(struct atp_softc *, atp_stroke_t *);
 
 /* updating fifo */
-static void          atp_reset_buf(struct atp_softc *sc);
-static void          atp_add_to_queue(struct atp_softc *, int, int, uint32_t);
+static void	     atp_reset_buf(struct atp_softc *);
+static void	     atp_add_to_queue(struct atp_softc *, int, int, int, uint32_t);
+
+/* Device methods. */
+static device_probe_t  atp_probe;
+static device_attach_t atp_attach;
+static device_detach_t atp_detach;
+static usb_callback_t  atp_intr;
+
+static const struct usb_config atp_xfer_config[ATP_N_TRANSFER] = {
+	[ATP_INTR_DT] = {
+		.type      = UE_INTERRUPT,
+		.endpoint  = UE_ADDR_ANY,
+		.direction = UE_DIR_IN,
+		.flags = {
+			.pipe_bof = 1, /* block pipe on failure */
+			.short_xfer_ok = 1,
+		},
+		.bufsize   = ATP_SENSOR_DATA_BUF_MAX,
+		.callback  = &atp_intr,
+	},
+	[ATP_RESET] = {
+		.type      = UE_CONTROL,
+		.endpoint  = 0, /* Control pipe */
+		.direction = UE_DIR_ANY,
+		.bufsize   = sizeof(struct usb_device_request) + MODE_LENGTH,
+		.callback  = &atp_reset_callback,
+		.interval  = 0,  /* no pre-delay */
+	},
+};
+
+static atp_stroke_t *
+atp_alloc_stroke(struct atp_softc *sc)
+{
+	atp_stroke_t *pstroke;
+
+	pstroke = TAILQ_FIRST(&sc->sc_stroke_free);
+	if (pstroke == NULL)
+		goto done;
 
+	TAILQ_REMOVE(&sc->sc_stroke_free, pstroke, entry);
+	memset(pstroke, 0, sizeof(*pstroke));
+	TAILQ_INSERT_TAIL(&sc->sc_stroke_used, pstroke, entry);
 
-usb_error_t
-atp_req_get_report(struct usb_device *udev, void *data)
+	sc->sc_n_strokes++;
+done:
+	return (pstroke);
+}
+
+static void
+atp_free_stroke(struct atp_softc *sc, atp_stroke_t *pstroke)
 {
-	struct usb_device_request req;
+	if (pstroke == NULL)
+		return;
 
-	req.bmRequestType = UT_READ_CLASS_INTERFACE;
-	req.bRequest = UR_GET_REPORT;
-	USETW2(req.wValue, (uint8_t)0x03 /* type */, (uint8_t)0x00 /* id */);
-	USETW(req.wIndex, 0);
-	USETW(req.wLength, MODE_LENGTH);
+	sc->sc_n_strokes--;
 
-	return (usbd_do_request(udev, NULL /* mutex */, &req, data));
+	TAILQ_REMOVE(&sc->sc_stroke_used, pstroke, entry);
+	TAILQ_INSERT_TAIL(&sc->sc_stroke_free, pstroke, entry);
 }
 
-static int
-atp_set_device_mode(device_t dev, interface_mode mode)
+static void
+atp_init_stroke_pool(struct atp_softc *sc)
 {
-	struct atp_softc     *sc;
-	usb_device_request_t  req;
-	usb_error_t           err;
+	u_int x;
 
-	if ((mode != RAW_SENSOR_MODE) && (mode != HID_MODE))
-		return (ENXIO);
+	TAILQ_INIT(&sc->sc_stroke_free);
+	TAILQ_INIT(&sc->sc_stroke_used);
 
-	sc = device_get_softc(dev);
+	sc->sc_n_strokes = 0;
 
-	sc->sc_mode_bytes[0] = mode;
-	req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
-	req.bRequest = UR_SET_REPORT;
-	USETW2(req.wValue, (uint8_t)0x03 /* type */, (uint8_t)0x00 /* id */);
-	USETW(req.wIndex, 0);
-	USETW(req.wLength, MODE_LENGTH);
-	err = usbd_do_request(sc->sc_usb_device, NULL, &req, sc->sc_mode_bytes);
-	if (err != USB_ERR_NORMAL_COMPLETION)
-		return (ENXIO);
+	memset(&sc->sc_strokes_data, 0, sizeof(sc->sc_strokes_data));
 
-	return (0);
+	for (x = 0; x != ATP_MAX_STROKES; x++) {
+		TAILQ_INSERT_TAIL(&sc->sc_stroke_free, &sc->sc_strokes_data[x],
+		    entry);
+	}
 }
 
-void
+static usb_error_t
+atp_set_device_mode(struct atp_softc *sc, interface_mode newMode)
+{
+	uint8_t mode_value;
+	usb_error_t err;
+
+	if ((newMode != RAW_SENSOR_MODE) && (newMode != HID_MODE))
+		return (USB_ERR_INVAL);
+
+	if ((newMode == RAW_SENSOR_MODE) &&
+	    (sc->sc_family == TRACKPAD_FAMILY_FOUNTAIN_GEYSER))
+		mode_value = (uint8_t)0x04;
+	else
+		mode_value = newMode;
+
+	err = usbd_req_get_report(sc->sc_usb_device, NULL /* mutex */,
+	    sc->sc_mode_bytes, sizeof(sc->sc_mode_bytes), 0 /* interface idx */,
+	    0x03 /* type */, 0x00 /* id */);
+	if (err != USB_ERR_NORMAL_COMPLETION) {
+		DPRINTF("Failed to read device mode (%d)\n", err);
+		return (err);
+	}
+
+	if (sc->sc_mode_bytes[0] == mode_value)
+		return (err);
+
+	/*
+	 * XXX Need to wait at least 250ms for hardware to get
+	 * ready. The device mode handling appears to be handled
+	 * asynchronously and we should not issue these commands too
+	 * quickly.
+	 */
+	tsleep(&atp_set_device_mode, 0, "WHW", hz / 4);
+
+	sc->sc_mode_bytes[0] = mode_value;
+	return (usbd_req_set_report(sc->sc_usb_device, NULL /* mutex */,
+	    sc->sc_mode_bytes, sizeof(sc->sc_mode_bytes), 0 /* interface idx */,
+	    0x03 /* type */, 0x00 /* id */));
+}
+
+static void
 atp_reset_callback(struct usb_xfer *xfer, usb_error_t error)
 {
 	usb_device_request_t   req;
 	struct usb_page_cache *pc;
 	struct atp_softc      *sc = usbd_xfer_softc(xfer);
 
+	uint8_t mode_value;
+	if (sc->sc_family == TRACKPAD_FAMILY_FOUNTAIN_GEYSER)
+		mode_value = 0x04;
+	else
+		mode_value = RAW_SENSOR_MODE;
+
 	switch (USB_GET_STATE(xfer)) {
 	case USB_ST_SETUP:
-		sc->sc_mode_bytes[0] = RAW_SENSOR_MODE;
+		sc->sc_mode_bytes[0] = mode_value;
 		req.bmRequestType = UT_WRITE_CLASS_INTERFACE;
 		req.bRequest = UR_SET_REPORT;
 		USETW2(req.wValue,
@@ -550,17 +949,14 @@ atp_reset_callback(struct usb_xfer *xfer, usb_error_t error)
 static int
 atp_enable(struct atp_softc *sc)
 {
-	/* Allocate the dynamic buffers */
-	if (atp_softc_populate(sc) != 0) {
-		atp_softc_unpopulate(sc);
-		return (ENOMEM);
-	}
+	if (sc->sc_state & ATP_ENABLED)
+		return (0);
 
 	/* reset status */
-	memset(sc->sc_strokes, 0, sizeof(sc->sc_strokes));
-	sc->sc_n_strokes = 0;
 	memset(&sc->sc_status, 0, sizeof(sc->sc_status));
-	sc->sc_idlecount = 0;
+
+	atp_init_stroke_pool(sc);
+
 	sc->sc_state |= ATP_ENABLED;
 
 	DPRINTFN(ATP_LLEVEL_INFO, "enabled atp\n");
@@ -570,126 +966,94 @@ atp_enable(struct atp_softc *sc)
 static void
 atp_disable(struct atp_softc *sc)
 {
-	atp_softc_unpopulate(sc);
-
 	sc->sc_state &= ~(ATP_ENABLED | ATP_VALID);
 	DPRINTFN(ATP_LLEVEL_INFO, "disabled atp\n");
 }
 
-/* Allocate dynamic memory for some fields in softc. */
-static int
-atp_softc_populate(struct atp_softc *sc)
+static void
+fg_interpret_sensor_data(struct atp_softc *sc, u_int data_len)
 {
-	const struct atp_dev_params *params = sc->sc_params;
-
-	if (params == NULL) {
-		DPRINTF("params uninitialized!\n");
-		return (ENXIO);
-	}
-	if (params->data_len) {
-		sc->sensor_data = malloc(params->data_len * sizeof(int8_t),
-		    M_USB, M_WAITOK);
-		if (sc->sensor_data == NULL) {
-			DPRINTF("mem for sensor_data\n");
-			return (ENXIO);
-		}
-	}
-
-	if (params->n_xsensors != 0) {
-		sc->base_x = malloc(params->n_xsensors * sizeof(*(sc->base_x)),
-		    M_USB, M_WAITOK);
-		if (sc->base_x == NULL) {
-			DPRINTF("mem for sc->base_x\n");
-			return (ENXIO);
-		}
-
-		sc->cur_x = malloc(params->n_xsensors * sizeof(*(sc->cur_x)),
-		    M_USB, M_WAITOK);
-		if (sc->cur_x == NULL) {
-			DPRINTF("mem for sc->cur_x\n");
-			return (ENXIO);
-		}
-
-		sc->pressure_x =
-			malloc(params->n_xsensors * sizeof(*(sc->pressure_x)),
-			    M_USB, M_WAITOK);
-		if (sc->pressure_x == NULL) {
-			DPRINTF("mem. for pressure_x\n");
-			return (ENXIO);
-		}
-	}
+	u_int n_xpspans = 0;
+	u_int n_ypspans = 0;
+	uint8_t status_bits;
 
-	if (params->n_ysensors != 0) {
-		sc->base_y = malloc(params->n_ysensors * sizeof(*(sc->base_y)),
-		    M_USB, M_WAITOK);
-		if (sc->base_y == NULL) {
-			DPRINTF("mem for base_y\n");
-			return (ENXIO);
-		}
+	const struct fg_dev_params *params =
+	    (const struct fg_dev_params *)sc->sc_params;
 
-		sc->cur_y = malloc(params->n_ysensors * sizeof(*(sc->cur_y)),
-		    M_USB, M_WAITOK);
-		if (sc->cur_y == NULL) {
-			DPRINTF("mem for cur_y\n");
-			return (ENXIO);
-		}
+	fg_extract_sensor_data(sc->sc_sensor_data, params->n_xsensors, X,
+	    sc->sc_cur_x, params->prot);
+	fg_extract_sensor_data(sc->sc_sensor_data, params->n_ysensors, Y,
+	    sc->sc_cur_y, params->prot);
 
-		sc->pressure_y =
-			malloc(params->n_ysensors * sizeof(*(sc->pressure_y)),
-			    M_USB, M_WAITOK);
-		if (sc->pressure_y == NULL) {
-			DPRINTF("mem. for pressure_y\n");
-			return (ENXIO);
+	/*
+	 * If this is the initial update (from an untouched
+	 * pad), we should set the base values for the sensor
+	 * data; deltas with respect to these base values can
+	 * be used as pressure readings subsequently.
+	 */
+	status_bits = sc->sc_sensor_data[params->data_len - 1];
+	if (((params->prot == FG_TRACKPAD_TYPE_GEYSER3) ||
+	     (params->prot == FG_TRACKPAD_TYPE_GEYSER4))  &&
+	    ((sc->sc_state & ATP_VALID) == 0)) {
+		if (status_bits & FG_STATUS_BASE_UPDATE) {
+			memcpy(sc->sc_base_x, sc->sc_cur_x,
+			    params->n_xsensors * sizeof(*sc->sc_base_x));
+			memcpy(sc->sc_base_y, sc->sc_cur_y,
+			    params->n_ysensors * sizeof(*sc->sc_base_y));
+			sc->sc_state |= ATP_VALID;
+			return;
 		}
 	}
 
-	return (0);
-}
+	/* Get pressure readings and detect p-spans for both axes. */
+	fg_get_pressures(sc->sc_pressure_x, sc->sc_cur_x, sc->sc_base_x,
+	    params->n_xsensors);
+	fg_detect_pspans(sc->sc_pressure_x, params->n_xsensors,
+	    FG_MAX_PSPANS_PER_AXIS, sc->sc_pspans_x, &n_xpspans);
+	fg_get_pressures(sc->sc_pressure_y, sc->sc_cur_y, sc->sc_base_y,
+	    params->n_ysensors);
+	fg_detect_pspans(sc->sc_pressure_y, params->n_ysensors,
+	    FG_MAX_PSPANS_PER_AXIS, sc->sc_pspans_y, &n_ypspans);
 
-/* Free dynamic memory allocated for some fields in softc. */
-static void
-atp_softc_unpopulate(struct atp_softc *sc)
-{
-	const struct atp_dev_params *params = sc->sc_params;
+	/* Update strokes with new pspans to detect movements. */
+	if (fg_update_strokes(sc, sc->sc_pspans_x, n_xpspans, sc->sc_pspans_y, n_ypspans))
+		sc->sc_status.flags |= MOUSE_POSCHANGED;
 
-	if (params == NULL) {
-		return;
-	}
-	if (params->n_xsensors != 0) {
-		if (sc->base_x != NULL) {
-			free(sc->base_x, M_USB);
-			sc->base_x = NULL;
-		}
+	sc->sc_ibtn = (status_bits & FG_STATUS_BUTTON) ? MOUSE_BUTTON1DOWN : 0;
+	sc->sc_status.button = sc->sc_ibtn;
 
-		if (sc->cur_x != NULL) {
-			free(sc->cur_x, M_USB);
-			sc->cur_x = NULL;
-		}
+	/*
+	 * The Fountain/Geyser device continues to trigger interrupts
+	 * at a fast rate even after touchpad activity has
+	 * stopped. Upon detecting that the device has remained idle
+	 * beyond a threshold, we reinitialize it to silence the
+	 * interrupts.
+	 */
+	if ((sc->sc_status.flags  == 0) && (sc->sc_n_strokes == 0)) {
+		sc->sc_idlecount++;
+		if (sc->sc_idlecount >= ATP_IDLENESS_THRESHOLD) {
+			/*
+			 * Use the last frame before we go idle for
+			 * calibration on pads which do not send
+			 * calibration frames.
+			 */
+			const struct fg_dev_params *params =
+			    (const struct fg_dev_params *)sc->sc_params;
 
-		if (sc->pressure_x != NULL) {
-			free(sc->pressure_x, M_USB);
-			sc->pressure_x = NULL;
-		}
-	}
-	if (params->n_ysensors != 0) {
-		if (sc->base_y != NULL) {
-			free(sc->base_y, M_USB);
-			sc->base_y = NULL;
-		}
+			DPRINTFN(ATP_LLEVEL_INFO, "idle\n");
 
-		if (sc->cur_y != NULL) {
-			free(sc->cur_y, M_USB);
-			sc->cur_y = NULL;
-		}
+			if (params->prot < FG_TRACKPAD_TYPE_GEYSER3) {
+				memcpy(sc->sc_base_x, sc->sc_cur_x,
+				    params->n_xsensors * sizeof(*(sc->sc_base_x)));
+				memcpy(sc->sc_base_y, sc->sc_cur_y,
+				    params->n_ysensors * sizeof(*(sc->sc_base_y)));
+			}
 
-		if (sc->pressure_y != NULL) {
-			free(sc->pressure_y, M_USB);
-			sc->pressure_y = NULL;
+			sc->sc_idlecount = 0;
+			usbd_transfer_start(sc->sc_xfer[ATP_RESET]);
 		}
-	}
-	if (sc->sensor_data != NULL) {
-		free(sc->sensor_data, M_USB);
-		sc->sensor_data = NULL;
+	} else {
+		sc->sc_idlecount = 0;
 	}
 }
 
@@ -719,15 +1083,15 @@ atp_softc_unpopulate(struct atp_softc *sc)
  *   prot
  *       The protocol to use to interpret the data
  */
-static __inline void
-atp_interpret_sensor_data(const int8_t *sensor_data, u_int num, atp_axis axis,
-    int	*arr, atp_protocol prot)
+static void
+fg_extract_sensor_data(const int8_t *sensor_data, u_int num, atp_axis axis,
+    int	*arr, enum fountain_geyser_trackpad_type prot)
 {
 	u_int i;
 	u_int di;   /* index into sensor data */
 
 	switch (prot) {
-	case ATP_PROT_GEYSER1:
+	case FG_TRACKPAD_TYPE_GEYSER1:
 		/*
 		 * For Geyser 1, the sensors are laid out in pairs
 		 * every 5 bytes.
@@ -735,24 +1099,33 @@ atp_interpret_sensor_data(const int8_t *sensor_data, u_int num, atp_axis axis,
 		for (i = 0, di = (axis == Y) ? 1 : 2; i < 8; di += 5, i++) {
 			arr[i] = sensor_data[di];
 			arr[i+8] = sensor_data[di+2];
-			if (axis == X && num > 16)
+			if ((axis == X) && (num > 16))
 				arr[i+16] = sensor_data[di+40];
 		}
 
 		break;
-	case ATP_PROT_GEYSER2:
-	case ATP_PROT_GEYSER3:
+	case FG_TRACKPAD_TYPE_GEYSER2:
+		for (i = 0, di = (axis == Y) ? 1 : 19; i < num; /* empty */ ) {
+			arr[i++] = sensor_data[di++];
+			arr[i++] = sensor_data[di++];
+			di++;
+		}
+		break;
+	case FG_TRACKPAD_TYPE_GEYSER3:
+	case FG_TRACKPAD_TYPE_GEYSER4:
 		for (i = 0, di = (axis == Y) ? 2 : 20; i < num; /* empty */ ) {
 			arr[i++] = sensor_data[di++];
 			arr[i++] = sensor_data[di++];
 			di++;
 		}
 		break;
+	default:
+		break;
 	}
 }
 
-static __inline void
-atp_get_pressures(int *p, const int *cur, const int *base, int n)
+static void
+fg_get_pressures(int *p, const int *cur, const int *base, int n)
 {
 	int i;
 
@@ -770,24 +1143,24 @@ atp_get_pressures(int *p, const int *cur, const int *base, int n)
 		 * threshold; this will reduce the contribution from
 		 * lower pressure readings.
 		 */
-		if (p[i] <= atp_sensor_noise_threshold)
+		if ((u_int)p[i] <= FG_SENSOR_NOISE_THRESHOLD)
 			p[i] = 0; /* filter away noise */
 		else
-			p[i] -= atp_sensor_noise_threshold;
+			p[i] -= FG_SENSOR_NOISE_THRESHOLD;
 	}
 }
 
 static void
-atp_detect_pspans(int *p, u_int num_sensors,
-    u_int       max_spans, /* max # of pspans permitted */
-    atp_pspan  *spans,     /* finger spans */
-    u_int      *nspans_p)  /* num spans detected */
+fg_detect_pspans(int *p, u_int num_sensors,
+    u_int      max_spans, /* max # of pspans permitted */
+    fg_pspan  *spans,     /* finger spans */
+    u_int     *nspans_p)  /* num spans detected */
 {
 	u_int i;
 	int   maxp;             /* max pressure seen within a span */
 	u_int num_spans = 0;
 
-	enum atp_pspan_state {
+	enum fg_pspan_state {
 		ATP_PSPAN_INACTIVE,
 		ATP_PSPAN_INCREASING,
 		ATP_PSPAN_DECREASING,
@@ -797,7 +1170,7 @@ atp_detect_pspans(int *p, u_int num_sensors,
 	 * The following is a simple state machine to track
 	 * the phase of the pressure span.
 	 */
-	memset(spans, 0, max_spans * sizeof(atp_pspan));
+	memset(spans, 0, max_spans * sizeof(fg_pspan));
 	maxp = 0;
 	state = ATP_PSPAN_INACTIVE;
 	for (i = 0; i < num_sensors; i++) {
@@ -862,11 +1235,11 @@ atp_detect_pspans(int *p, u_int num_sensors,
 	/* post-process the spans */
 	for (i = 0; i < num_spans; i++) {
 		/* filter away unwanted pressure spans */
-		if ((spans[i].cum < atp_pspan_min_cum_pressure) ||
-		    (spans[i].width > atp_pspan_max_width)) {
+		if ((spans[i].cum < FG_PSPAN_MIN_CUM_PRESSURE) ||
+		    (spans[i].width > FG_PSPAN_MAX_WIDTH)) {
 			if ((i + 1) < num_spans) {
 				memcpy(&spans[i], &spans[i + 1],
-				    (num_spans - i - 1) * sizeof(atp_pspan));
+				    (num_spans - i - 1) * sizeof(fg_pspan));
 				i--;
 			}
 			num_spans--;
@@ -874,30 +1247,104 @@ atp_detect_pspans(int *p, u_int num_sensors,
 		}
 
 		/* compute this span's representative location */
-		spans[i].loc = spans[i].cog * atp_mickeys_scale_factor /
+		spans[i].loc = spans[i].cog * FG_SCALE_FACTOR /
 			spans[i].cum;
 
-		spans[i].matched = FALSE; /* not yet matched against a stroke */
+		spans[i].matched = false; /* not yet matched against a stroke */
 	}
 
 	*nspans_p = num_spans;
 }
 
+static void
+wsp_interpret_sensor_data(struct atp_softc *sc, u_int data_len)
+{
+	const struct wsp_dev_params *params = sc->sc_params;
+	wsp_finger_t fingers[WSP_MAX_FINGERS];
+	struct wsp_finger_sensor_data *source_fingerp;
+	u_int n_source_fingers;
+	u_int n_fingers;
+	u_int i;
+
+	/* validate sensor data length */
+	if ((data_len < params->finger_data_offset) ||
+	    ((data_len - params->finger_data_offset) %
+	     WSP_SIZEOF_FINGER_SENSOR_DATA) != 0)
+		return;
+
+	/* compute number of source fingers */
+	n_source_fingers = (data_len - params->finger_data_offset) /
+	    WSP_SIZEOF_FINGER_SENSOR_DATA;
+
+	if (n_source_fingers > WSP_MAX_FINGERS)
+		n_source_fingers = WSP_MAX_FINGERS;
+
+	/* iterate over the source data collecting useful fingers */
+	n_fingers = 0;
+	source_fingerp = (struct wsp_finger_sensor_data *)(sc->sc_sensor_data +
+	     params->finger_data_offset);
+
+	for (i = 0; i < n_source_fingers; i++, source_fingerp++) {
+		/* swap endianness, if any */
+		if (le16toh(0x1234) != 0x1234) {
+			source_fingerp->origin      = le16toh((uint16_t)source_fingerp->origin);
+			source_fingerp->abs_x       = le16toh((uint16_t)source_fingerp->abs_x);
+			source_fingerp->abs_y       = le16toh((uint16_t)source_fingerp->abs_y);
+			source_fingerp->rel_x       = le16toh((uint16_t)source_fingerp->rel_x);
+			source_fingerp->rel_y       = le16toh((uint16_t)source_fingerp->rel_y);
+			source_fingerp->tool_major  = le16toh((uint16_t)source_fingerp->tool_major);
+			source_fingerp->tool_minor  = le16toh((uint16_t)source_fingerp->tool_minor);
+			source_fingerp->orientation = le16toh((uint16_t)source_fingerp->orientation);
+			source_fingerp->touch_major = le16toh((uint16_t)source_fingerp->touch_major);
+			source_fingerp->touch_minor = le16toh((uint16_t)source_fingerp->touch_minor);
+			source_fingerp->multi       = le16toh((uint16_t)source_fingerp->multi);
+		}
+
+		/* check for minium threshold */
+		if (source_fingerp->touch_major == 0)
+			continue;
+
+		fingers[n_fingers].matched = false;
+		fingers[n_fingers].x       = source_fingerp->abs_x;
+		fingers[n_fingers].y       = -source_fingerp->abs_y;
+
+		n_fingers++;
+	}
+
+	if ((sc->sc_n_strokes == 0) && (n_fingers == 0))
+		return;
+
+	if (wsp_update_strokes(sc, fingers, n_fingers))
+		sc->sc_status.flags |= MOUSE_POSCHANGED;
+
+	switch(params->tp_type) {
+	case WSP_TRACKPAD_TYPE2:
+		sc->sc_ibtn = sc->sc_sensor_data[WSP_TYPE2_BUTTON_DATA_OFFSET];
+		break;
+	case WSP_TRACKPAD_TYPE3:
+		sc->sc_ibtn = sc->sc_sensor_data[WSP_TYPE3_BUTTON_DATA_OFFSET];
+		break;
+	default:
+		break;
+	}
+	sc->sc_status.button = sc->sc_ibtn ? MOUSE_BUTTON1DOWN : 0;
+}
+
 /*
  * Match a pressure-span against a stroke-component. If there is a
- * match, update the component's state and return TRUE.
+ * match, update the component's state and return true.
  */
 static boolean_t
-atp_match_stroke_component(atp_stroke_component *component,
-    const atp_pspan *pspan, atp_stroke_type stroke_type)
+fg_match_stroke_component(fg_stroke_component_t *component,
+    const fg_pspan *pspan, atp_stroke_type stroke_type)
 {
 	int   delta_mickeys;
 	u_int min_pressure;
 
 	delta_mickeys = pspan->loc - component->loc;
 
-	if (abs(delta_mickeys) > atp_max_delta_mickeys)
-		return (FALSE); /* the finger span is too far out; no match */
+	if (abs(delta_mickeys) > (int)FG_MAX_DELTA_MICKEYS)
+		return (false); /* the finger span is too far out; no match */
 
 	component->loc = pspan->loc;
 
@@ -929,72 +1376,126 @@ atp_match_stroke_component(atp_stroke_component *component,
 		delta_mickeys = 0;
 
 	component->delta_mickeys = delta_mickeys;
-	return (TRUE);
+	return (true);
 }
 
 static void
-atp_match_strokes_against_pspans(struct atp_softc *sc, atp_axis axis,
-    atp_pspan *pspans, u_int n_pspans, u_int repeat_count)
+fg_match_strokes_against_pspans(struct atp_softc *sc, atp_axis axis,
+    fg_pspan *pspans, u_int n_pspans, u_int repeat_count)
 {
-	u_int i, j;
+	atp_stroke_t *strokep;
 	u_int repeat_index = 0;
+	u_int i;
 
 	/* Determine the index of the multi-span. */
 	if (repeat_count) {
-		u_int cum = 0;
 		for (i = 0; i < n_pspans; i++) {
-			if (pspans[i].cum > cum) {
+			if (pspans[i].cum > pspans[repeat_index].cum)
 				repeat_index = i;
-				cum = pspans[i].cum;
-			}
 		}
 	}
 
-	for (i = 0; i < sc->sc_n_strokes; i++) {
-		atp_stroke *stroke  = &sc->sc_strokes[i];
-		if (stroke->components[axis].matched)
+	TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry) {
+		if (strokep->components[axis].matched)
 			continue; /* skip matched components */
 
-		for (j = 0; j < n_pspans; j++) {
-			if (pspans[j].matched)
+		for (i = 0; i < n_pspans; i++) {
+			if (pspans[i].matched)
 				continue; /* skip matched pspans */
 
-			if (atp_match_stroke_component(
-				    &stroke->components[axis], &pspans[j],
-				    stroke->type)) {
+			if (fg_match_stroke_component(
+			    &strokep->components[axis], &pspans[i],
+			    strokep->type)) {
+
 				/* There is a match. */
-				stroke->components[axis].matched = TRUE;
+				strokep->components[axis].matched = true;
 
 				/* Take care to repeat at the multi-span. */
-				if ((repeat_count > 0) && (j == repeat_index))
+				if ((repeat_count > 0) && (i == repeat_index))
 					repeat_count--;
 				else
-					pspans[j].matched = TRUE;
+					pspans[i].matched = true;
 
-				break; /* skip to the next stroke */
+				break; /* skip to the next strokep */
 			}
 		} /* loop over pspans */
 	} /* loop over strokes */
 }
 
+static boolean_t
+wsp_match_strokes_against_fingers(struct atp_softc *sc,
+    wsp_finger_t *fingers, u_int n_fingers)
+{
+	boolean_t movement = false;
+	atp_stroke_t *strokep;
+	u_int i;
+
+	/* reset the matched status for all strokes */
+	TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry)
+		strokep->matched = false;
+
+	for (i = 0; i != n_fingers; i++) {
+		u_int least_distance_sq = WSP_MAX_ALLOWED_MATCH_DISTANCE_SQ;
+		atp_stroke_t *strokep_best = NULL;
+
+		TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry) {
+			int instantaneous_dx;
+			int instantaneous_dy;
+			u_int d_squared;
+
+			if (strokep->matched)
+				continue;
+
+			instantaneous_dx = fingers[i].x - strokep->x;
+			instantaneous_dy = fingers[i].y - strokep->y;
+
+			/* skip strokes which are far away */
+			d_squared =
+			    (instantaneous_dx * instantaneous_dx) +
+			    (instantaneous_dy * instantaneous_dy);
+
+			if (d_squared < least_distance_sq) {
+				least_distance_sq = d_squared;
+				strokep_best = strokep;
+			}
+		}
+
+		strokep = strokep_best;
+
+		if (strokep != NULL) {
+			fingers[i].matched = true;
+
+			strokep->matched          = true;
+			strokep->instantaneous_dx = fingers[i].x - strokep->x;
+			strokep->instantaneous_dy = fingers[i].y - strokep->y;
+			strokep->x                = fingers[i].x;
+			strokep->y                = fingers[i].y;
+
+			atp_advance_stroke_state(sc, strokep, &movement);
+		}
+	}
+	return (movement);
+}
+
 /*
  * Update strokes by matching against current pressure-spans.
- * Return TRUE if any movement is detected.
+ * Return true if any movement is detected.
  */
 static boolean_t
-atp_update_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
-    u_int n_xpspans, atp_pspan *pspans_y, u_int n_ypspans)
+fg_update_strokes(struct atp_softc *sc, fg_pspan *pspans_x,
+    u_int n_xpspans, fg_pspan *pspans_y, u_int n_ypspans)
 {
-	u_int       i, j;
-	atp_stroke *stroke;
-	boolean_t   movement = FALSE;
-	u_int       repeat_count = 0;
+	atp_stroke_t *strokep;
+	atp_stroke_t *strokep_next;
+	boolean_t movement = false;
+	u_int repeat_count = 0;
+	u_int i;
+	u_int j;
 
 	/* Reset X and Y components of all strokes as unmatched. */
-	for (i = 0; i < sc->sc_n_strokes; i++) {
-		stroke = &sc->sc_strokes[i];
-		stroke->components[X].matched = FALSE;
-		stroke->components[Y].matched = FALSE;
+	TAILQ_FOREACH(strokep, &sc->sc_stroke_used, entry) {
+		strokep->components[X].matched = false;
+		strokep->components[Y].matched = false;
 	}
 
 	/*
@@ -1033,35 +1534,40 @@ atp_update_strokes(struct atp_softc *sc, atp_pspan *pspans_x,
 	 */
 	repeat_count = abs(n_xpspans - n_ypspans);
 
-	atp_match_strokes_against_pspans(sc, X, pspans_x, n_xpspans,
+	fg_match_strokes_against_pspans(sc, X, pspans_x, n_xpspans,
 	    (((repeat_count != 0) && ((n_xpspans < n_ypspans))) ?
 		repeat_count : 0));
-	atp_match_strokes_against_pspans(sc, Y, pspans_y, n_ypspans,
+	fg_match_strokes_against_pspans(sc, Y, pspans_y, n_ypspans,
 	    (((repeat_count != 0) && (n_ypspans < n_xpspans)) ?
 		repeat_count : 0));
 
 	/* Update the state of strokes based on the above pspan matches. */
-	for (i = 0; i < sc->sc_n_strokes; i++) {
-		stroke = &sc->sc_strokes[i];
-		if (stroke->components[X].matched &&
-		    stroke->components[Y].matched) {
-			atp_advance_stroke_state(sc, stroke, &movement);
+	TAILQ_FOREACH_MUTABLE(strokep, &sc->sc_stroke_used, entry, strokep_next) {
+
+		if (strokep->components[X].matched &&
+		    strokep->components[Y].matched) {
+			strokep->matched = true;
+			strokep->instantaneous_dx =
+			    strokep->components[X].delta_mickeys;
+			strokep->instantaneous_dy =
+			    strokep->components[Y].delta_mickeys;
+			atp_advance_stroke_state(sc, strokep, &movement);
 		} else {
 			/*
 			 * At least one component of this stroke
 			 * didn't match against current pspans;
 			 * terminate it.
 			 */
-			atp_terminate_stroke(sc, i);
+			atp_terminate_stroke(sc, strokep);
 		}
 	}
 
 	/* Add new strokes for pairs of unmatched pspans */
 	for (i = 0; i < n_xpspans; i++) {
-		if (pspans_x[i].matched == FALSE) break;
+		if (pspans_x[i].matched == false) break;
 	}
 	for (j = 0; j < n_ypspans; j++) {
-		if (pspans_y[j].matched == FALSE) break;
+		if (pspans_y[j].matched == false) break;
 	}
 	if ((i < n_xpspans) && (j < n_ypspans)) {
 #ifdef USB_DEBUG
